
dofile ("C:\\Users\\tiago\\Desktop\\Munster_2014\\class10\\MonoLakeModel_Complete.lua")

------
function clone (luaTable)

	local newTable = {}
	for key,val in pairs(luaTable) do
		if type(val) == 'table' then
			val = clone (val)
		end
		newTable [key] = val
	end
	return newTable
end
------ 
function createObserverChart (terrame_object, plotLabels)
	chart = Observer {
		type 		= "chart",
		subject     = terrame_object,
		attributes  = plotLabels.attributes,
		curveLabels = plotLabels.attributes,
		title       = plotLabels.title,
		xLabel      = plotLabels.xLabel,
		yLabel      = plotLabels.yLabel
	}
end

function createPlot (simul)
	simul.plot = Cell (simul.outcomes)
	createObserverChart (simul.plot, simul.plotLabels)

end
------------------
function createTimer (simul)
	simul.timer = Timer {
		Event{time = 1, period = 1, action = function(e)
			for key, val in pairs (simul.exportPolicies) do
				changes(simul.model[key])
				simul.outcomes[key] = simul.model[key].outcomes.elevation
			end
			simul.plot:notify(e:getTime())
		end}
	}
end
-----------------

function run (simul, time)
	simul.timer:execute (time)
end
--------

------
function createScenarios (simul)
	simul.model = {}
	for attr, value in pairs(simul.exportPolicies) do
		simul.model[attr] = clone (monoLake)
		simul.model[attr].policy.waterExport = simul.exportPolicies[attr]
		simul.outcomes[attr] = simul.model[attr].outcomes.elevation 
	end
end

-----------
function Scenarios (simul)

	-- start the model
	createScenarios (simul)

	-- create Plot
	createPlot (simul)

	-- timer
	createTimer (simul)

	return simul
end


simul = Scenarios {
	exportPolicies  = { highExport = 100, middleExport = 50, lowExport = 25,  verylowExport = 10, noExport = 0 },
	outcomes        = { highExport = 0,   middleExport =  0, lowExport =  0,  verylowExport = 0, noExport = 0 },
	plotLabels = {
		  attributes = {"highExport", "middleExport", "lowExport", "verylowExport", "noExport"}, 
	      title      = "MonoLake - Elevation", 
	      xLabel     = "years", 
	      yLabel     = "Elevation (feet)"
	}

}
-----
run (simul, 50) 




